;												
; STANDARD Einstellungen fr ATmega8			
; Bernhard.Erfurt@gmx.de						
; 11/2019										
;												
; LCD 2x16 oder 4x16							
;												
; Kalender mit Schaltjahr bis Jahr 2099			
;												

;												
; LED ROT blinkt: Programm Check Error			
; LED ROT+GELB blinkt: Interrupt Error			
; LED ROT+GELB+GRN blinkt: WDR Error (nicht in dieser Version)	
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> 										
; PB1 ==> 										
; PB2 ==> 										
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> 										
; PB7 ==> 										
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"
.include "MACRO.asm"
; LED-CP(Clock)									
.equ CLOCK_PIN_NR				= 0
.equ CLOCK_DDR					= DDRD
.equ CLOCK_PORT					= PORTD
; LED-DAT(Daten)								
.equ DAT_PIN_NR					= 1
.equ DAT_DDR					= DDRD
.equ DAT_PORT					= PORTD
; LED-GRUEN										
.equ GRUEN_PIN_NR				= 5
.equ GRUEN_DDR					= DDRD
.equ GRUEN_PORT					= PORTD
; LED-GELB										
.equ GELB_PIN_NR				= 6
.equ GELB_DDR					= DDRD
.equ GELB_PORT					= PORTD
; LED-ROT										
.equ ROT_PIN_NR					= 7
.equ ROT_DDR					= DDRD
.equ ROT_PORT					= PORTD
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=SRAM_START		; 0x0060 START Adresse 		

.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; REGISTER										
.def NULL 	= R12
.def EINS 	= R14
.def VOLL	= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   		; Timer0 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	
;-------------------------------------------------------------------------------
; Unkorrekten Interrupt Aufruf 													
INTERRUPT_ERROR:
	GELB_ON
	ROT_ON
	rcall wait_100ms
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
	rcall wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)					; STACK initialisieren				
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	rcall WDR_INITIALISIERUNG				; WDR_INITIALISIERUNG				
	rcall SRAM_CLEAR						; SRAM lschen						
	rcall REGISTER_CLEAR					; REGISTER-CLEAR					
	rcall STARTWERTE						; Startwerte						
	rcall PORT_INITIALISIERUNG				; LED_INITIALISIERUNG				
	rcall PROGRAMM_CHECK					; CHECK								
	sei										; Interrupts freigeben				
	GRUEN_ON
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
LOOP:
	rcall BEISPIEL_A

	GELB_ON
	rcall WAIT_100ms
	GELB_OFF
	rcall WAIT_1s

	rcall BEISPIEL_B

	GELB_ON
	rcall WAIT_100ms
	GELB_OFF
	rcall WAIT_1s

rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEISPIEL_A:
	DAT_H		; Punkt 			(L=on)
	ENABLE
	DAT_L		; g		 			(L=on)
	ENABLE
	DAT_L		; f		 			(L=on)
	ENABLE
	DAT_L		; e		 			(L=on)
	ENABLE
	DAT_H		; d		 			(L=on)
	ENABLE
	DAT_L		; c		 			(L=on)
	ENABLE
	DAT_L		; b		 			(L=on)
	ENABLE
	DAT_L		; a		 			(L=on)
	ENABLE


	DAT_H		; 0 unten rechts	(H=on)
	ENABLE
	DAT_L		; 1					(H=on)
	ENABLE
	DAT_L		; 2					(H=on)
	ENABLE
	DAT_H		; 3 unten links		(H=on)
	ENABLE
	DAT_H		; 4 oben rechts		(H=on)
	ENABLE
	DAT_L		; 5					(H=on)
	ENABLE
	DAT_L		; 6					(H=on)
	ENABLE
	DAT_H		; 7 oben links		(H=on)
	ENABLE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEISPIEL_B:
	DAT_H		; Punkt 			(L=on)
	ENABLE
	DAT_L		; g		 			(L=on)
	ENABLE
	DAT_L		; f		 			(L=on)
	ENABLE
	DAT_L		; e		 			(L=on)
	ENABLE
	DAT_H		; d		 			(L=on)
	ENABLE
	DAT_L		; c		 			(L=on)
	ENABLE
	DAT_L		; b		 			(L=on)
	ENABLE
	DAT_L		; a		 			(L=on)
	ENABLE


	DAT_L		; unten rechts		(H=on)
	ENABLE
	DAT_H		; 					(H=on)
	ENABLE
	DAT_H		; 					(H=on)
	ENABLE
	DAT_L		;  unten links		(H=on)
	ENABLE
	DAT_L		;  oben rechts		(H=on)
	ENABLE
	DAT_H		; 					(H=on)
	ENABLE
	DAT_H		; 					(H=on)
	ENABLE
	DAT_L		; oben links		(H=on)
	ENABLE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "SONSTIGES.asm"
.include "WAIT.asm"

